unit uConfig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TConfigInfo = class(TObject)
  public
    Start: Boolean;
    OnMessage: Boolean;
    Bottom: Boolean;
    constructor Create;
    procedure SaveSettings;
    procedure LoadSettings;
  end;

type
  TfmConfig = class(TForm)
    gbView: TGroupBox;
    cbStart: TCheckBox;
    cbMessage: TCheckBox;
    GroupBox1: TGroupBox;
    cbBottom: TCheckBox;
    btnOK: TButton;
    btnCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ConfigInfo: TConfigInfo = nil;

implementation

{$R *.DFM}

uses
  Registry;

constructor TConfigInfo.Create;
begin
  inherited Create;

  LoadSettings;
end;

procedure TConfigInfo.LoadSettings;
var
  RegIni: TRegIniFile;
begin
  // Do not localize
  RegIni := TRegIniFile.Create('Software\GExperts\Debug');
  try
    Start := RegIni.ReadBool('View', 'Startup', False);
    OnMessage := RegIni.ReadBool('View', 'OnMessage', False);
    Bottom := RegIni.ReadBool('Messages', 'Bottom', False);
  finally
    RegIni.Free;
  end;
end;

procedure TConfigInfo.SaveSettings;
var
  RegIni: TRegIniFile;
begin
  RegIni := TRegIniFile.Create('Software\GExperts\Debug');
  try
    RegIni.WriteBool('View', 'Startup', Start);
    RegIni.WriteBool('View', 'OnMessage', OnMessage);
    RegIni.WriteBool('Messages', 'Bottom', Bottom);
  finally
    RegIni.Free;
  end;
end;


procedure TfmConfig.FormCreate(Sender: TObject);
begin
  cbStart.Checked := ConfigInfo.Start;
  cbMessage.Checked := ConfigInfo.OnMessage;
  cbBottom.Checked := ConfigInfo.Bottom;
end;

procedure TfmConfig.btnOKClick(Sender: TObject);
begin
  ConfigInfo.Start := cbStart.Checked;
  ConfigInfo.OnMessage := cbMessage.Checked;
  ConfigInfo.Bottom := cbBottom.Checked;
  ConfigInfo.SaveSettings;
  ModalResult := mrOK;
end;

initialization
  ConfigInfo := TConfigInfo.Create;

finalization
  ConfigInfo.Free;
  ConfigInfo := nil;

end.
