unit GX_FileProp;

interface

//! StH: This unit has been completely prepared for localization
//! StH: This unit is fully compatible with C++ Builder

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Buttons;

type
  TfmFileProp = class(TForm)
    pgeProperties: TPageControl;
    tabProperties: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnCancel: TButton;
    btnOK: TButton;
    edName: TEdit;
    edDesc: TEdit;
    imIcon: TImage;
    Icon: TLabel;
    Label5: TLabel;
    cbExecType: TComboBox;
    edFilename: TEdit;
    sbFile: TSpeedButton;
    Label4: TLabel;
    edProg: TEdit;
    sbProg: TSpeedButton;
    procedure sbFileClick(Sender: TObject);
    procedure edFilenameExit(Sender: TObject);
    procedure sbProgClick(Sender: TObject);
    procedure cbExecTypeClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    FFavoriteFilesForm: TForm;
  public
    { Public declarations }
    property FavoriteFilesForm: TForm write FFavoriteFilesForm;
  end;

implementation

{$R *.DFM}

uses
  GX_uFavFiles;

procedure TfmFileProp.sbFileClick(Sender: TObject);
begin
  (FFavoriteFilesForm as TfmFavFiles).SetFilter;

  if FileExists(edFileName.Text) then
    TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.FileName := edFileName.Text;

  if TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.Execute then
  begin
    edFilename.Text := TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.FileName;
    TfmFavFiles(FFavoriteFilesForm).GetIcon(edFileName.Text, imIcon);
  end;
end;

procedure TfmFileProp.edFilenameExit(Sender: TObject);
begin
  TfmFavFiles(FFavoriteFilesForm).GetIcon(edFileName.Text, imIcon);
end;

procedure TfmFileProp.sbProgClick(Sender: TObject);
begin
  (FFavoriteFilesForm as TfmFavFiles).dlgGetFiles.FilterIndex := 7;
  if FileExists(edprog.Text) then
    TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.FileName := edProg.Text;
  if TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.Execute then
    edProg.Text := TfmFavFiles(FFavoriteFilesForm).dlgGetFiles.FileName;
end;

procedure TfmFileProp.cbExecTypeClick(Sender: TObject);
var
  ItemEnabled: Boolean;
begin
  ItemEnabled := (cbExecType.ItemIndex = 2);

  sbProg.Enabled := ItemEnabled;
  edProg.Enabled := ItemEnabled;
  if ItemEnabled then
    edProg.Color := clWindow
  else
    edprog.Color := clBtnFace;
end;

procedure TfmFileProp.FormActivate(Sender: TObject);
begin
  cbExecTypeClick(cbExecType);
end;

end.

