unit GX_dlgFolder;

interface

//! StH: This unit has been completely prepared for localization
//! StH: This unit is fully compatible with C++ Builder

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfmNewFolder = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edFolder: TEdit;
    Label2: TLabel;
    cbType: TComboBox;
    btnCancel: TButton;
    btnOK: TButton;
    procedure edFolderChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbTypeDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure cbTypeMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
  private
    { Private declarations }
    FFavoriteFilesForm: TForm;
  public
    { Public declarations }
    property FavoriteFilesForm: TForm write FFavoriteFilesForm;
  end;

implementation

{$R *.DFM}

uses
  GX_uFiles, GX_uFavFiles;

procedure TfmNewFolder.edFolderChange(Sender: TObject);
begin
  btnOK.Enabled := (Length(edFolder.Text) > 0);
end;

procedure TfmNewFolder.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to MaxFolders-1 do
    cbType.Items.AddObject(FolderNames[i], Pointer(i));
  cbType.ItemIndex := 0;
end;

procedure TfmNewFolder.cbTypeDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  try
    with cbType.Canvas do
    begin
      if odSelected in State then
        Brush.Color := clHighlight
      else
        Brush.Color := clWindow;

      FillRect(Rect);
      (FFavoriteFilesForm as TfmFavFiles).imFolders.Draw(cbType.Canvas, Rect.Left+3, Rect.Top+1, Index*2);
      TextOut(Rect.Left+22, Rect.Top+3, cbType.Items[Index]);
    end;
  except
    on E: Exception do
    begin
      // ignore
    end;
  end;
end;

procedure TfmNewFolder.cbTypeMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 18; //cbType.Canvas.TextHeight('W'); //! StH: This is not really good practice
end;

end.
