library GExpert4;
{
GExperts License Agreement

GExperts is copyright 1996-1999 by GExperts, Inc, Erik Berry, and several
other authors who have submitted their code for inclusion. This license
agreement only covers code written by GExperts, Inc. and Erik Berry. You
should contact the other authors concerning their respective copyrights
and conditions.

The rules governing the use of GExperts and the GExperts source code are
derived from the official Open Source Definition, available at
http://www.opensource.org/. The conditions and limitations are as follows:

You may not use the GExperts source code to develop a proprietary
commercial or shareware product; this includes the creation of
proprietary plugins and libraries for commercial products.  You may use
the GExperts source code in a non-proprietary (Open Source/freeware)
project, under the terms listed below.

You may not use the GExperts source code to create and distribute custom
versions of GExperts under the "GExperts" name.  If you do modify and
distribute custom versions of GExperts, the binary distribution must be
named differently and clearly marked so users can tell they are not using
the official GExperts distribution.  A visible and unmodified version of
this license must appear in any modified distribution of GExperts.

Custom distributions of GExperts must include all of the custom changes
as a patch file that can be appplied to the original source code.  This
restriction is in place to protect the integrity of the original author's
source code.  No support for modified versions of GExperts will be
provided by the original authors or on the GExperts mailing lists.

All works derived from GExperts must be distributed under a license
compatible with this license and the official Open Source Definition,
which can be obtained from http://www.opensource.org/.

Please note that GExperts, Inc. and the other contributing authors hereby
state that this package is provided "as is" and without any express or
implied warranties, including, but not without limitation, the implied
warranties of merchantability and fitness for a particular purpose. In
other words, we accept no liability for any damage that may result from
using GExperts or programs that use the GExperts source code.

If you have license questions, please email Erik Berry at eberry@gexperts.com.
}

uses
  Forms,
  ToolIntf,
  ExptIntf,
  GX_uExperts in 'src\GX_uExperts.pas',
  GX_GExperts in 'src\GX_GExperts.pas',
  GX_Procs in 'src\GX_Procs.pas' {fmProcs},
  GX_uGenFunc in 'src\GX_uGenFunc.pas',
  GX_About in 'src\GX_About.pas' {fmAbout},
  GX_ExpMgr in 'src\GX_ExpMgr.pas' {fmExperts},
  GX_uResults in 'src\GX_uResults.pas' {fmResults},
  GX_Search in 'src\GX_Search.pas',
  GX_DlgGrep in 'src\GX_DlgGrep.pas' {fmGrep},
  GX_uGrepOptions in 'src\GX_uGrepOptions.pas' {fmGrepOptions},
  GX_MsgExp in 'src\GX_MsgExp.pas' {fmMsgExp},
  GX_EditWrt in 'src\GX_EditWrt.pas',
  GX_PBackup in 'src\GX_PBackup.pas' {fmBackup},
  GX_uBackupOptions in 'src\GX_uBackupOptions.pas' {fmBackupOptions},
  GX_uBackupConfig in 'src\GX_uBackupConfig.pas' {fmBackupConfig},
  GX_uTabs in 'src\GX_uTabs.pas' {fmTabs},
  GX_uClean in 'src\GX_uClean.pas' {fmClean},
  GX_uNotify in 'src\GX_uNotify.pas',
  GX_EditRead in 'src\GX_EditRead.pas',
  GX_uClip in 'src\GX_uClip.pas' {fmClip},
  GX_uClipSet in 'src\GX_uClipSet.pas' {fmClipSet},
  GX_uFavFiles in 'FileMgr\GX_uFavFiles.pas' {fmFavFiles},
  GX_uFavOptions in 'FileMgr\GX_uFavOptions.pas' {fmFavOptions},
  GX_uFiles in 'FileMgr\GX_uFiles.pas',
  GX_dlgFolder in 'FileMgr\GX_dlgFolder.pas' {fmNewFolder},
  GX_FileProp in 'FileMgr\GX_FileProp.pas' {fmFileProp},
  GX_uClassBrowser in 'Class2\GX_uClassBrowser.pas' {fmClassBrowser},
  GX_uClassBrowserOptions in 'Class2\GX_uClassBrowserOptions.PAS' {fmClassBrowserOptions},
  GX_uClassOptions in 'Class2\GX_uClassOptions.pas' {fmClassRep},
  GX_MethProp in 'Class2\GX_MethProp.PAS' {fmMethodProp},
  GX_uClassProp in 'Class2\GX_uClassProp.pas' {fmClassProp},
  GX_uIdentify in 'Class2\GX_uIdentify.pas' {fmIdentify},
  GX_uParsing in 'Class2\GX_uParsing.pas' {fmParsing},
  GX_uPAStoHTML in 'src\GX_uPAStoHTML.pas' {fmPasToHTML},
  GX_CodeLib in 'src\GX_CodeLib.pas' {fmCodeLib},
  GX_CodeNew in 'src\GX_CodeNew.pas' {fmCodeDBNew},
  GX_CodeSrch in 'src\GX_CodeSrch.pas' {fmCodeSearch},
  GX_CodeOpt in 'src\GX_CodeOpt.pas' {fmCodeOptions},
  GX_uPRFunc in 'src\GX_uPRFunc.pas',
  GX_uPreview in 'src\GX_uPreview.pas',
  GX_uProgress in 'src\GX_uProgress.pas' {fmProgress},
  GX_uASCII in 'src\GX_uASCII.pas' {fmASCII},
  GX_ExeExplr in 'src\GX_ExeExplr.pas' {fmEXEView},
  GX_uPE in 'src\GX_uPE.pas',
  GX_CompReplace in 'src\GX_CompReplace.pas' {fmCompReplace},
  GX_uGrid in 'src\GX_uGrid.pas' {fmCompGrid},
  GX_ShortCuts in 'src\GX_ShortCuts.pas' {fmShortCuts},
  GX_uSubst in 'src\GX_uSubst.pas',
  GX_uDepend in 'src\GX_uDepend.pas' {fmDepend},
  GX_uDependProp in 'src\GX_uDependProp.pas' {fmDependProp},
  GX_uMsgDlg in 'src\GX_uMsgDlg.pas' {fmMsgExpDlg},
  GX_uLayout in 'src\GX_uLayout.pas' {fmLayout},
  GX_uToDo in 'src\GX_uToDo.pas' {fmToDo},
  GX_uToDoOptions in 'src\GX_uToDoOptions.pas' {fmToDoOptions},
  GX_EditorExpert in 'src\GX_EditorExpert.pas',
  GX_eComment in 'Editor\GX_eComment.pas' {fmCommentConfig},
  GX_eDate in 'Editor\GX_eDate.pas' {fmDateFormat},
  GX_eFindDelimiter in 'Editor\GX_eFindDelimiter.pas',
  GX_eHeader in 'Editor\GX_eHeader.pas' {fmHeaderFormat},
  GX_uShortcut in 'src\GX_uShortcut.pas' {fmShortcut},
  GX_ProofReaderExpert in 'src\GX_ProofReaderExpert.pas',
  GX_ProofReaderDM in 'src\GX_ProofReaderDM.pas' {dmProofReader: TDataModule},
  GX_ProofReaderConfig in 'src\GX_ProofReaderConfig.pas' {fmProofReaderConfig},
  GX_IDEEnhance in 'src\GX_IDEEnhance.pas',
  GX_HookDebugString in 'src\GX_HookDebugString.pas',
  GX_uSingleIDE in 'OneD4all\GX_uSingleIDE.pas' {fmSingleIDE},
  GX_uToolbar in 'src\GX_uToolbar.pas',
  GX_uToolbarButtons in 'src\GX_uToolbarButtons.pas',
  FakeIdeDock in 'IdeDock\WithDock\FakeIdeDock.pas' {FakeIdeDockForm},
  IdeDock in 'IdeDock\ideDock.pas' {IdeDockForm},
  GX_uPriorityBoost in 'src\GX_uPriorityBoost.pas' {fmPriorityBoostConfig},
  GX_uConfigurationInfo in 'src\GX_uConfigurationInfo.pas',
  GX_uConfigure in 'src\GX_uConfigure.pas' {fmConfiguration},
  GX_uMultiLinePalette in 'src\GX_uMultiLinePalette.pas',
  GX_uEditorEnhance in 'src\GX_uEditorEnhance.pas',
  GX_VerDepConst in 'src\GX_VerDepConst.pas',
  GX_uProjOptionSets in 'ProjOptionsExpert\GX_uProjOptionSets.pas' {fmProjOptionSets},
  GX_uProjOptMap in 'ProjOptionsExpert\GX_uProjOptMap.pas',
  GX_uProjOptOptions in 'ProjOptionsExpert\GX_uProjOptOptions.pas' {fmProjOptOptions},
  GX_uMultilineHost in 'src\GX_uMultilineHost.pas';

{$R *.RES}

{ Register the expert }
function InitExpert(ToolServices: TIToolServices; RegisterProc: TExpertRegisterProc;
  var Terminate: TExpertTerminateProc): Boolean; export; stdcall;
begin
  Result := (ToolServices <> nil);

  if Result and (not BuiltWithPackages) then
  begin
    Result := False;
    ShowNoPackagesError;
  end;

  if Result then
  begin
    ExptIntf.ToolServices := ToolServices;
    Application.Handle := ToolServices.GetParentHandle;
    //Terminate := GX_GExperts.Cleanup;
    RegisterProc(TGExperts.Create);
  end;
end;

exports
  InitExpert name ExpertEntryPoint resident,
  ShowExpertManager,
  CloseExpertManager,
  ShowGrep,
  CloseGrep;

begin
end.

