{ GX_CondDefine.inc }

// Third-Party Product Defines
// ------------------------------------------------------------------------
// Define VCLZIP below if you own a copy of Kevin Boylan's VCLZip
// If not, the Project Backup expert will not be compiled into GExperts
// Download a trial version from: http://ourworld.compuserve.com/homepages/boylank/

// Define SYNTAXMEMO below if you own a copy of David Brock's TSyntaxMemo
// If not, the Pascal to HTML expert will not be compiled into GExperts and
// the various text editors will not offer syntax highlighting.
// Download a trial version from: http://www.dbrocksoftware.com/

// Define ACEREPORTER below if you own a copy of SCT Associates
// ACE Reporter.  If not, you will not be able to print from the
// Grep and PE Information experts.
// Download a trial version from: http://www.sct-associates.com/

// Define DELPHIDEBUGGINGPACKAGE below if you own a copy of the
// Econos - Stefan Hoffmeister Delphi Debugging Package.
// This adds stack traces and source code mapping for debugging
// Download a trial version from: http://www.econos.de/software/borland/

// Switch off all third-party product defines
{$UNDEF SYNTAXMEMO}{$UNDEF ACEREPORTER}{$UNDEF VCLZIP}{$UNDEF GX_EII} {$UNDEF DELPHIDEBUGGINGPACKAGE}

// Then turn things on selectively.
{.$DEFINE SYNTAXMEMO}
{.$DEFINE ACEREPORTER}
{.$DEFINE VCLZIP}
{.$DEFINE DELPHIDEBUGGINGPACKAGE}

// We want to include support for EII: editor experts, toolbar, etc.
// Not recommended for C++Builder yet, as it is fairly unstable
{$DEFINE GX_EII}

// We want to build a GExperts DLL (strongly recommended)
{$DEFINE DLL}

// We want IDE docking for those IDEs that we support
// For Delphi 5 and greater compile with the DsnIdeXX runtime package
{$DEFINE EnableIdeDockingSupport}

// Don't include the experts which use the BDE (Code Proofreader, Code Librarian)
{.$DEFINE GX_NOBDE}

// We may want build GExperts so that it does NOT require
// packages - only used currently for debugging C++Builder integration
{.$DEFINE GX_NotPackageBuilt}

// Misc GExperts Defines (do not change the items below!)
// ---------------------------------------------------------------

{ TODO -oDelphi 5: Delete me}
{$IFDEF BreakD5Compilation} --- {$ENDIF BreakD5Compilation}
{ Borland Delphi 5.0 }
{$IFDEF VER130}
  {$DEFINE GX_VER130_up}
  {$DEFINE GX_VER125_up}
  {$DEFINE GX_VER120_up}
  {$DEFINE GX_VER110_up}
  {$DEFINE GX_VER100_up}
  {$DEFINE GX_VER93_up}
  {$DEFINE GX_VER90_up}
  {$DEFINE GX_VER80_up}

  {$DEFINE GX_VCL10_up}
  {$DEFINE GX_VCL20_up}
  {$DEFINE GX_VCL30_up}
  {$DEFINE GX_VCL35_up}
  {$DEFINE GX_VCL40_up}

  {$DEFINE GX_Interfaces}
  {$DEFINE GX_Resourcestring}
  {$DEFINE GX_DefaultParam}
  {$DEFINE GX_Overload}
  {$DEFINE GX_CppHeaderDefines}

  {$DEFINE GX_Delphi}
{$ENDIF VER130}

{ Borland C++Builder 4.0 }
{$IFDEF VER125}
  {$DEFINE GX_VER125_up}
  {$DEFINE GX_VER120_up}
  {$DEFINE GX_VER110_up}
  {$DEFINE GX_VER100_up}
  {$DEFINE GX_VER93_up}
  {$DEFINE GX_VER90_up}
  {$DEFINE GX_VER80_up}

  {$DEFINE GX_VCL10_up}
  {$DEFINE GX_VCL20_up}
  {$DEFINE GX_VCL30_up}
  {$DEFINE GX_VCL35_up}
  {$DEFINE GX_VCL40_up}

  {$DEFINE GX_Interfaces}
  {$DEFINE GX_Resourcestring}
  {$DEFINE GX_DefaultParam}
  {$DEFINE GX_Overload}
  {$DEFINE GX_CppHeaderDefines}

  {$DEFINE GX_BCB}
{$ENDIF VER125}

{ Borland Delphi 4.0 }
{$IFDEF VER120}
  {$DEFINE GX_VER120_up}
  {$DEFINE GX_VER110_up}
  {$DEFINE GX_VER100_up}
  {$DEFINE GX_VER93_up}
  {$DEFINE GX_VER90_up}
  {$DEFINE GX_VER80_up}

  {$DEFINE GX_VCL10_up}
  {$DEFINE GX_VCL20_up}
  {$DEFINE GX_VCL30_up}
  {$DEFINE GX_VCL35_up}
  {$DEFINE GX_VCL40_up}

  {$DEFINE GX_Interfaces}
  {$DEFINE GX_Resourcestring}
  {$DEFINE GX_DefaultParam}
  {$DEFINE GX_Overload}
  {$DEFINE GX_CppHeaderDefines}

  {$DEFINE GX_Delphi}
{$ENDIF VER120}

{ Borland C++Builder 3.0 }
{$IFDEF VER110}
  {$DEFINE GX_VER110_up}
  {$DEFINE GX_VER100_up}
  {$DEFINE GX_VER93_up}
  {$DEFINE GX_VER90_up}
  {$DEFINE GX_VER80_up}

  {$DEFINE GX_VCL10_up}
  {$DEFINE GX_VCL20_up}
  {$DEFINE GX_VCL30_up}
  {$DEFINE GX_VCL35_up}

  {$DEFINE GX_Interfaces}
  {$DEFINE GX_Resourcestring}
  {$DEFINE GX_DefaultParam}
  {$DEFINE GX_CppHeaderDefines}

  {$DEFINE GX_BCB}
{$ENDIF VER110}

{ Borland Delphi 3.0 }
{$IFDEF VER100}
  {$DEFINE GX_VER100_up}
  {$DEFINE GX_VER93_up}
  {$DEFINE GX_VER90_up}
  {$DEFINE GX_VER80_up}

  {$DEFINE GX_VCL10_up}
  {$DEFINE GX_VCL20_up}
  {$DEFINE GX_VCL30_up}

  {$DEFINE GX_Interfaces}
  {$DEFINE GX_Resourcestring}

  {$DEFINE GX_Delphi}
{$ENDIF VER100}


// ******************************************************************
// This item determines whether we support docking in the IDE

{$IFNDEF GX_VER120_up}
  // Only Delphi 4.0 and later allow docking in the IDE
  {$UNDEF EnableIdeDockingSupport}
{$ENDIF GX_VER120_up}


// ******************************************************************
// These items determine whether we can build with
// native Tools API

{$UNDEF GX_UseNativeToolsApi}

{$IFDEF GX_VER120_up}
  {$DEFINE GX_UseNativeToolsApi}
{$ENDIF GX_VER120_up}

{$IFDEF GX_NotPackageBuilt}
  {$UNDEF GX_UseNativeToolsApi}
{$ENDIF GX_NotPackageBuilt}


// ******************************************************************
// These items determine whether we want subclass the main window
// for multi-line tabs

{$UNDEF GX_MultiLinePaletteSubclass}

{$IFDEF VER100} // Delphi 3.0
  {$DEFINE GX_MultiLinePaletteSubclass}
{$ENDIF VER100}

{$IFDEF VER110} // C++ Builder 3.0
  {$DEFINE GX_MultiLinePaletteSubclass}
{$ENDIF VER110}

