unit GX_DbugIntf;

interface

uses
  Windows, SysUtils, Messages, Forms, Registry, Dialogs;

procedure SendDebugEx(const Msg: string; MType: TMsgDlgType);
procedure SendDebug(const Msg: string);
function StartDebugWin: hWnd;

implementation

function StartDebugWin: hWnd;
var
  Count: Integer;
  DebugFilename: string;
  Buf: array[0..MAX_PATH + 1] of Char;
  si: TStartupInfo;
  pi: TProcessInformation;
begin
  Result := 0;
  with TRegIniFile.Create('\Software\GExperts') do
  try
    DebugFilename := ReadString('Debug', 'FilePath', '');
  finally
    Free;
  end;
  if Trim(DebugFileName) = '' then
  begin
    GetModuleFileName(HINSTANCE, Buf, SizeOf(Buf)-1);
    DebugFileName := ExtractFilePath(StrPas(Buf))+'GDebug.exe';
  end;
  if (Trim(DebugFilename) <> '') and FileExists(DebugFilename) then
  begin
    FillChar(si, SizeOf(si), #0);
    si.cb := SizeOf(si);
    si.dwFlags := STARTF_USESHOWWINDOW;
    si.wShowWindow := SW_SHOW;
    if not CreateProcess( PChar(DebugFilename), nil, nil, nil, False, 0, nil, nil,
                          si, pi ) then
    begin
      Result := INVALID_HANDLE_VALUE;
      Exit;
    end;
    try
      WaitForInputIdle(pi.hProcess, 2 * 1000); // wait for 2 seconds to get idle
    finally
      CloseHandle(pi.hThread);
      CloseHandle(pi.hProcess);
    end;
    Result := 0;
    Count := 0;
    while (Result = 0) and (Count < 1000) do
    begin
      Sleep(250);
      Result := FindWindow('TfmDebug', nil);
      inc(Count);
    end;
  end;
end;

procedure SendDebugEx(const Msg: string; MType: TMsgDlgType);
var
  CDS: TCopyDataStruct;
  DebugWin: hWnd;
begin
  DebugWin := FindWindow('TfmDebug', nil);
  if DebugWin = 0 then
    DebugWin := StartDebugWin;
  if DebugWin <> 0 then
  begin
    CDS.cbData := Length(Msg) + 4;
    CDS.dwData := 0;
    CDS.lpData := PChar(#1+Char(ord(MType) + 1)+Msg+#0); //PMsg;
    SendMessage(DebugWin, WM_COPYDATA, Application.Handle, LParam(@CDS));
  end;
end;

procedure SendDebug(const Msg: string);
begin
  SendDebugEx(Msg, mtInformation);
end;

end.

